#include <iostream>
using namespace std;

int main()
{
	const int B_MAX = 1000;
	const int N_MAX = 50;
	
	int B = 0; // knapsack capacity; <= 1000
	int n = 0; // number of items; <= 50
	
	int weight[N_MAX] = {0};
	
	while (cin >> B >> n)
	{
		char knapsack[N_MAX][B_MAX + 1];	// B_MAX + 1 because 0 must be included 
											// 'i' means impossible
											// 'n' means possible and not selecting
											// 's' means possible and selecting
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j <= B; j++)
				knapsack[i][j] = 'i';
		}

		// read weights
		for (int i = 0; i < n; i++) 
			cin >> weight[i];
			
		// the first item
		knapsack[0][0] = 'n';
		knapsack[0][weight[0]] = 's';
		
		// all the remaining items
		for (int i = 1; i < n; i++) // each iteration completes a row (item i + 1)
		{
			for (int j = 0; j <= B; j++) // each iteration complete a cell (capacity B)
			{
				if (j - weight[i] >= 0 && knapsack[i-1][j - weight[i]] != 'i')
					knapsack[i][j] = 's';
				else if (knapsack[i-1][j] != 'i')
					knapsack[i][j] = 'n';
			}
		}
		
		// whether it is possible to fill the knapsacl
		if (knapsack[n-1][B] == 'i')
			cout << 0 << endl;
		else 
		{
			cout << 1 << " ";

			// get the items to be included
			
			int capLeft = B; // remaining capacity
			for (int i = n - 1; i >= 0; i--)
			{
				if (knapsack[i][capLeft] == 's') // should be included
				{
					if (capLeft - weight[i] == 0) // the last item
					{
						cout << i + 1 << endl;
						break;
					}
					else 
						cout << i + 1 << " ";

					capLeft -= weight[i];
				}
			}
		}
	}
		
	return 0;
}
